package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.ActivityCouponBean;
import com.xx.hbhconsumer.data.http.respons.ClaimedCoupon;
import com.xx.hbhconsumer.data.http.respons.CouponGoodsBean;
import com.xx.hbhconsumer.data.http.respons.MyCouponBean;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class CouponRequest extends BaseRespons {

    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<MyCouponBean>> getUsedCouponList(int pageNum) {
        return getApiService().getUsedCouponList(pageNum);
    }
    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<MyCouponBean>> getUnUsedCouponList(int pageNum) {
        return getApiService().getUnUsedCouponList(pageNum);
    }
    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<ActivityCouponBean>> getCouponAppList(int pageNum) {
        return getApiService().getCouponAppList(pageNum);
    }
    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<Integer>> getCoupon(String couponId) {
        return getApiService().getCoupon(couponId);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<CouponGoodsBean>> getCouponGoodsList(String couponId, Integer minPrice, Integer maxPrice, String searchWord, String sortRules) {
        ApiParams<GetCouponGoodsListRequestBody> apiParams = new ApiParams<>();
        GetCouponGoodsListRequestBody requestBody = new GetCouponGoodsListRequestBody(couponId, minPrice, maxPrice, searchWord, sortRules);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getCouponGoodsList(body);
    }

    public class GetCouponGoodsListRequestBody {
        public String couponId;
        private Integer minPrice;
        private Integer maxPrice;
        public String searchWord;
        public String sortRules;


        public GetCouponGoodsListRequestBody(String couponId, Integer minPrice, Integer maxPrice, String searchWord, String sortRules) {
            this.couponId = couponId;
            this.minPrice = minPrice;
            this.maxPrice = maxPrice;
            this.searchWord = searchWord;
            this.sortRules = sortRules;
        }
    }
}
