package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean;
import com.xx.hbhconsumer.data.http.respons.MessageBean;
import com.xx.hbhconsumer.data.http.respons.UserInfoBean;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class MineRequest extends BaseRespons {

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<String>> updateUser(String nickname, String phone, Integer userId, String sex) {
        ApiParams<UpdateUserRequestBody> apiParams = new ApiParams<>();
        UpdateUserRequestBody requestBody = new UpdateUserRequestBody(nickname, phone, userId, "13", sex);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().updateUser(body);
    }
    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<CollectionBean>> memberCollectionList() {
        return getApiService().memberCollectionList();
    }


    /**
     * 获取广告列表
     * @return
     */
    public Observable<BaseResponse<MemberInfoBean>> memberInfo() {
        return getApiService().memberInfo();
    }

    /**
     * 获取广告列表
     * @return
     */
    public Observable<BasePageResponse<MessageBean>> getMessageList() {
        return getApiService().getMessageList(0, 1);
    }

    /**
     * 获取广告列表
     *
     * @return
     */
    public Observable<BaseResponse<Integer>> uploadPicture(String memberPicture) {
        ApiParams<UploadPictureRequestBody> apiParams = new ApiParams<>();
        UploadPictureRequestBody requestBody = new UploadPictureRequestBody(memberPicture);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().uploadPicture(body);
    }

    /**
     * 获取用户信息
     */
    public Observable<BaseResponse<UserInfoBean>> getUserInfo() {
        return getApiService().getUserInfo();
    }

    public class UploadPictureRequestBody {
        public String memberPicture;


        public UploadPictureRequestBody(String memberPicture) {
            this.memberPicture = memberPicture;
        }
    }

    public class UpdateUserRequestBody {
        public String nickName;
        public String phone;
        public Integer userId;
        public String userType;
        public String sex;


        public UpdateUserRequestBody(String nickName, String phone, Integer userId, String userType, String sex) {
            this.nickName = nickName;
            this.phone = phone;
            this.userId = userId;
            this.userType = userType;
            this.sex = sex;
        }
    }
}
