package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.AvailableCouponBean;
import com.xx.hbhconsumer.data.http.respons.ClaimedCoupon;
import com.xx.hbhconsumer.data.http.respons.OrderBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class OrderRequest extends BaseRespons {

    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<OrderBean>> getOrderList(String orderStatus, int pageNum) {
        return getApiService().getOrderList(orderStatus, pageNum);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<List<AvailableCouponBean>>> getAvailableCoupons(String couponType, String orderId, Integer userId) {
        ApiParams<GetAvailableCouponsRequestBody> apiParams = new ApiParams<>();
        GetAvailableCouponsRequestBody requestBody = new GetAvailableCouponsRequestBody(couponType, orderId, userId);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getAvailableCoupons(body);
    }

    public Observable<BaseResponse<Integer>> getCoupon(String couponId) {
        return getApiService().getCoupon(couponId);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<Boolean>> closeOrder(String businessId) {
        return getApiService().closeOrder(businessId);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<OrderBean>> getOrderDetail(String businessId) {
        return getApiService().getOrderDetail(businessId);
    }


    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<ClaimedCoupon>> getCouponAppList(String orderId) {
        ApiParams<GetClaimedCouponRequestBody> apiParams = new ApiParams<>();
        GetClaimedCouponRequestBody requestBody = new GetClaimedCouponRequestBody(orderId, null);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getClaimedCoupon(body);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<Boolean>> submitOrder(String orderId, String couponDetailId) {
        ApiParams<SubmitOrderRequestBody> apiParams = new ApiParams<>();
        SubmitOrderRequestBody requestBody = new SubmitOrderRequestBody(orderId, couponDetailId);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().submitOrder(body);
    }

    public class GetClaimedCouponRequestBody {
        public String orderId;
        public Integer userId;

        public GetClaimedCouponRequestBody(String orderId, Integer userId) {
            this.orderId = orderId;
            this.userId = userId;
        }
    }

    public class SubmitOrderRequestBody {
        public String businessId;
        public String couponDetailId;

        public SubmitOrderRequestBody(String businessId, String couponDetailId) {
            this.businessId = businessId;
            this.couponDetailId = couponDetailId;
        }
    }

    public class GetAvailableCouponsRequestBody {
        public String couponType;
        public String orderId;
        public Integer userId;

        public GetAvailableCouponsRequestBody(String couponType, String orderId, Integer userId) {
            this.couponType = couponType;
            this.orderId = orderId;
            this.userId = userId;
        }
    }
}
