package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.SearchGoodsBean;
import com.xx.hbhconsumer.data.http.respons.SearchShopBean;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import okhttp3.RequestBody;

public class SearchRequest extends BaseRespons {

    public Observable<BasePageResponse<SearchGoodsBean>> searchGoods(String searchWord, Integer minPrice, Integer maxPrice, String sortRules, String affiliatedCompany) {

        ApiParams<SearchGoodsRequestBody> apiParams = new ApiParams<SearchGoodsRequestBody>();
        SearchGoodsRequestBody requestBody = new SearchGoodsRequestBody(maxPrice, minPrice, searchWord, affiliatedCompany, sortRules);
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().searchGoods(body);
    }

    public Observable<BasePageResponse<SearchShopBean>> searchShop(String searchWord, String affiliatedCompany) {
        return getApiService().searchShop(searchWord, affiliatedCompany);
    }

    public Observable<BasePageResponse<SearchShopBean>> searchMerchant(String searchWord, String affiliatedCompany) {
        ApiParams<SearchMerchantRequestBody> apiParams = new ApiParams<SearchMerchantRequestBody>();
        SearchMerchantRequestBody requestBody = new SearchMerchantRequestBody(searchWord, affiliatedCompany);
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().searchMerchant(body);
    }

    public class SearchMerchantRequestBody {
        public String searchWord;
        public String affiliatedCompany;


        public SearchMerchantRequestBody(String searchWord, String affiliatedCompany) {
            this.searchWord = searchWord;
            this.affiliatedCompany = affiliatedCompany;
        }
    }

    public class SearchGoodsRequestBody {
        public Integer maxPrice;
        public Integer minPrice;
        public String searchWord;
        public String affiliatedCompany;
        public String sortRules;

        public SearchGoodsRequestBody(Integer maxPrice, Integer minPrice, String searchWord, String affiliatedCompany, String sortRules) {
            this.maxPrice = maxPrice;
            this.minPrice = minPrice;
            this.searchWord = searchWord;
            this.sortRules = sortRules;
            this.affiliatedCompany = affiliatedCompany;
        }
    }
}
