package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean;
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean;
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.data.http.respons.ShopBean;
import com.xx.hbhconsumer.data.http.respons.ShopDetailBean;
import com.xx.hbhconsumer.data.http.respons.ShopGoodsBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class ShopRequest extends BaseRespons {

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<ShopBean>> getTopShop(String affiliatedCompany) {
        return getApiService().getTopShop(affiliatedCompany);
    }


    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<List<ShopBean>>> getTopShopList(String affiliatedCompany) {
        return getApiService().getTopShopList(affiliatedCompany);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<List<ShopAndGoodsBean>>> getShopList(String affiliatedCompany) {
        return getApiService().getShopList(affiliatedCompany);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<ShopDetailBean>> getShopDetail(String affiliatedCompany) {
        return getApiService().getShopDetail(affiliatedCompany);
    }

    public Observable<BaseResponse<List<ShopGoodsBean>>> getSixCommodity(String merchantId) {
        return getApiService().getSixCommodity(merchantId);
    }

    public Observable<BasePageResponse<ShopGoodsBean>> getShopGoodsList(List<String> categoryIdList, String merchantId, String searchWord, String sortRules) {
        ApiParams<ShopGoodsListRequestBody> apiParams = new ApiParams<>();
        ShopGoodsListRequestBody requestBody = new ShopGoodsListRequestBody(categoryIdList, merchantId, searchWord, sortRules);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getShopGoodsList(body);
    }

    public class ShopGoodsListRequestBody {
        public List<String> categoryIdList;
        public String merchantId;
        public String searchWord;
        public String sortRules;


        public ShopGoodsListRequestBody(List<String> categoryIdList, String merchantId, String searchWord, String sortRules) {
            this.categoryIdList = categoryIdList;
            this.merchantId = merchantId;
            this.searchWord = searchWord;
            this.sortRules = sortRules;
        }
    }


    /**
     * 获取广告列表
     * affiliatedCompany  string 所属公司 1- 河西 2-滨海
     * rotographDisplay string  1-消费者app 2-商户app 3-企业app
     */
    public class AdvertisingRequestBody {
        public String affiliatedCompany;
        public String rotographDisplay;

        public AdvertisingRequestBody(String affiliatedCompany,String rotographDisplay) {
            this.affiliatedCompany = affiliatedCompany;
            this.rotographDisplay = rotographDisplay;
        }
    }

    /**
     * "activityShop": 传店铺类型 1-河西 2-滨海
     * "isPublish": 传APP类型 1-消费者 2-企业 3-商户
     */
    public class HomeRequestBody {
        public String activityShop;
        public String isPublish;


        public HomeRequestBody(String activityShop, String isPublish) {
            this.activityShop = activityShop;
            this.isPublish = isPublish;
        }
    }
}
